CON

    hoffs = 0
    voffs = 0
    hres  = 320
    vres  = 240

    LCD_RS = 26
    LCD_WR = 25

OBJ

    Render: "lcd_renderer"

PUB Start(_video_ram)

    blnk := @line_indicator
    base0 := @scanline0
    base1 := @scanline1
    base2 := @scanline2
    base3 := @scanline3
    
    wordfill(base0, $0000, hres)
    wordfill(base1, $0000, hres)
    wordfill(base2, $0000, hres)
    wordfill(base3, $0000, hres)

    cognew(@driver, 0)
    waitcnt(CNT + CLKFREQ)

    Render.Start(_video_ram, 0, blnk, base0)
    Render.Start(_video_ram, 1, blnk, base1)
    Render.Start(_video_ram, 2, blnk, base2)
    Render.Start(_video_ram, 3, blnk, base3)

DAT

driver          jmp     #begin

' driver parameters

blnk            long    0
base0           long    0
base1           long    0
base2           long    0
base3           long    0

' Upset lcd h/w and relatives.

begin               mov     outa, out_mask
                    mov     dira, dir_mask
                
                    ' Reset
{
                    or      OUTA, rstmask           ' RESET=1
                    mov     a, ms5_delay
                    add     a, cnt
                    waitcnt a, #0
                    andn    OUTA, rstmask           ' RESET=0
                    mov     a, ms5_delay
                    add     a, cnt
                    waitcnt a, #0
                    or      OUTA, rstmask           ' RESET=0
                    mov     a, ms5_delay
                    add     a, cnt
                    waitcnt a, #0

                    andn    OUTA, csmask            ' CS=0
}

                    ' Initialization sequence
                    movs    command, #init_cmd
                    mov     ecnt, #44
                    call    #command                
                
                    ' Clear screen
                    or      OUTA, rsmask            ' RS=1 -> Command Mode
                    mov     a, OUTA
                    andn    a, datamask
                    or      a, #$22                 ' Write data
                    mov     OUTA, a
                    andn    OUTA, wrmask
                    or      OUTA, wrmask
                    andn    OUTA, rsmask            ' RS=0 -> Data Mode
                    andn    OUTA, datamask
                    mov     scnt, #240
:l3                 mov     ecnt, #320
:l2                 andn    OUTA, wrmask
                    or      OUTA, wrmask
                    djnz    ecnt, #:l2
                    djnz    scnt, #:l3
                    
                    ' From now on the write window is hres x vres pixels
                    movs    command, #write_window
                    mov     ecnt, #5
                    call    #command                
                    or      OUTA, rsmask            ' RS=1 -> Command Mode
                    mov     a, OUTA
                    andn    a, datamask
                    or      a, #$22                 ' Write data
                    mov     OUTA, a
                    andn    OUTA, wrmask
                    or      OUTA, wrmask
                    andn    OUTA, rsmask            ' RS=0 -> Data Mode

' Setup complete, enter display loop.

                    mov     time, CNT
                    add     time, frame_time

vsync               mov     lcnt, #vres
                    wrlong  lcnt, blnk              ' signal vertical retrace

                    waitcnt time, frame_time        ' simulate vertical retrace

                    mov     scnt, #vres/4
                    mov     lcnt, #0

:vloop
                    mov     sb_ptr, base0
                    mov     ecnt, #hres/16
                    wrlong  lcnt, blnk

                    'mov     a, CNT
                    'add     a, scanline_time

:hloop0             rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    djnz    ecnt, #:hloop0

                    'waitcnt a, #0

                    add     lcnt, #1

                    mov     sb_ptr, base1
                    mov     ecnt, #hres/16
                    wrlong  lcnt, blnk

                    'mov     a, CNT
                    'add     a, scanline_time

:hloop1             rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    djnz    ecnt, #:hloop1

                    'waitcnt a, #0

                    add     lcnt, #1

                    mov     sb_ptr, base2
                    mov     ecnt, #hres/16
                    wrlong  lcnt, blnk

                    'mov     a, CNT
                    'add     a, scanline_time

:hloop2             rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    djnz    ecnt, #:hloop2

                    'waitcnt a, #0

                    add     lcnt, #1

                    mov     sb_ptr, base3
                    mov     ecnt, #hres/16
                    wrlong  lcnt, blnk

                    'mov     a, CNT
                    'add     a, scanline_time

:hloop3             rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    rdword  OUTA, sb_ptr
                    or      OUTA, wrmask
                    add     sb_ptr, #2
                    djnz    ecnt, #:hloop3

                    'waitcnt a, #0

                    add     lcnt, #1

                    djnz    scnt, #:vloop

                    jmp     #vsync

command             mov     data, 0-0
                    mov     cmd, data
                    shr     cmd, #16
                    and     data, datamask

                    ' Write COM
                    or      OUTA, rsmask            ' RS=1 -> Command Mode
                    mov     a, OUTA
                    andn    a, datamask
                    or      a, cmd
                    mov     OUTA, a
                    andn    OUTA, wrmask
                    or      OUTA, wrmask
                
                    ' Write DATA
                    andn    OUTA, rsmask            ' RS=0 -> Data Mode
                    mov     a, OUTA
                    andn    a, datamask
                    or      a, data
                    mov     OUTA, a
                    andn    OUTA, wrmask
                    or      OUTA, wrmask

                    add     command, #1
                    djnz    ecnt, #command
command_ret         ret

' initialised data and/or presets

dir_mask            long    (1 << LCD_RS) | (1 << LCD_WR) | %0000000000000000_11111_111111_11111
out_mask            long    (1 << LCD_RS) | (1 << LCD_WR) | %0000000000000000_11111_111111_11111

datamask            long    %0000000000000000_11111_111111_11111

rsmask              long    (1 << LCD_RS)
wrmask              long    (1 << LCD_WR)
{
csmask              long    %000000000000_0_1_0_0_00000_000000_00000
rstmask             long    %000000000000_1_0_0_0_00000_000000_00000
}

ms5_delay           long    80_000 * 5
frame_time          long    1_334_657           ' 16.68mS (VGA 640x480 60Hz)
'scanline_time       long    5_085               ' 31.78uS x 2
scanline_time       long    5_480               ' min. line emitting time

init_cmd            long    $00_0001
                    long    $03_A8A4
                    long    $0C_0000
                    long    $0D_080C
                    long    $0E_2B00
                    long    $1E_00B7
                    long    $01_2B3F
                    long    $02_0600
                    long    $10_0000
                    long    $11_6058            ' decrement Y then increment X (landscape)
                    long    $05_0000
                    long    $06_0000
                    long    $16_EF1C
                    long    $17_0003
                    long    $07_0233
                    long    $0B_0000
                    long    $0F_0000
                    long    $41_0000
                    long    $42_0000
                    long    $48_0000
                    long    $49_013F
                    long    $4A_0000
                    long    $4B_0000
                    long    $30_0707
                    long    $31_0204
                    long    $32_0204
                    long    $33_0502
                    long    $34_0507
                    long    $35_0204
                    long    $36_0204
                    long    $37_0502
                    long    $3A_0302
                    long    $3B_0302
                    long    $23_0000
                    long    $24_0000
                    long    $25_5000            ' frame frequency 60Hz
                    long    $28_0006
                    long    $2F_12BE
                    long    $12_6CEB

full_screen         long    $44_0000 | (239 << 8) | 0
                    long    $45_0000 | 0
                    long    $46_0000 | 319
                    long    $4e_0000 | 0
                    long    $4f_0000 | 319
                    long    $22_0000

write_window        long    $44_0000 | ((voffs+vres-1) << 8) | voffs
                    long    $45_0000 | hoffs
                    long    $46_0000 | hoffs+hres-1
                    long    $4e_0000 | voffs
                    long    $4f_0000 | hoffs+hres-1
                    long    $22_0000

' uninitialised data and/or temporaries

a                   res     1
cmd                 res     1                       ' command
data                res     1                       ' data

ecnt                res     1                       ' element count
lcnt                res     1                       ' line counter
scnt                res     1                       ' scanlines
ccnt                res     1

sb_ptr              res     1                       ' scanbuffer pointer
time                res     1

                    fit     $1F0


DAT

line_indicator      long    0

scanline0           word    0[hres]
scanline1           word    0[hres]
scanline2           word    0[hres]
scanline3           word    0[hres]
